open OUnit
open SetList

let test_nointer_00 () =
  let l1 = [] in
  let l2 = [] in
  let b = nointer l1 l2 in
  error_assert "b ( := nointer l1 l2 ) = true" (b = true);
  ()

let _ = push_test
  "test_nointer_00"
   test_nointer_00

let test_nointer_01 () =
  let l1 = [0] in
  let l2 = [] in
  let b = nointer l1 l2 in
  error_assert "b ( := nointer l1 l2 ) = true" (b = true);
  ()

let _ = push_test
  "test_nointer_01"
   test_nointer_01

let test_nointer_02 () =
  let l1 = [] in
  let l2 = [0] in
  let b = nointer l1 l2 in
  error_assert "b ( := nointer l1 l2 ) = true" (b = true);
  ()

let _ = push_test
  "test_nointer_02"
   test_nointer_02

let test_nointer_03 () =
  let l1 = [0] in
  let l2 = [0] in
  let b = nointer l1 l2 in
  error_assert "b ( := nointer l1 l2 ) = false" (b = false);
  ()

let _ = push_test
  "test_nointer_02"
   test_nointer_02

(* #debug:2020-04-03 *)
let test_nointer_10 () =
  let l1 = [0; 1; 2; 3; 4; 5; 6; 7; 8; 9; 10; 11; 12; 13; 14; 15; 16; 17; 18; 19] in
  let l2 = [] in
  let b = nointer l1 l2 in
  error_assert "b ( := nointer l1 l2 ) = true" (b = true);
  ()

let _ = push_test
  "test_nointer_10"
   test_nointer_10

(* #debug:2020-04-06 *)
let test_subset_of_10 () =
  let l1 = [2] in
  let l2 = [0; 1; 2; 3; 4; 5; 6; 7; 8; 9; 10; 11; 12; 13; 14; 15; 16; 17; 18; 19] in
  let b = subset_of l1 l2 in
  error_assert
    "b = true"
    (b = true);
  ()
let _ = push_test
  "test_subset_of_10"
   test_subset_of_10

let test_subset_of_11 () =
  let l1 = [2] in
  let l2 = [0; 1; 3; 4; 5; 6; 7; 8; 9; 10; 11; 12; 13; 14; 15; 16; 17; 18; 19] in
  let b = subset_of l1 l2 in
  error_assert
    "b = false"
    (b = false);
  ()

let _ = push_test
  "test_subset_of_11"
   test_subset_of_11

(*  test_01.(i) = (A, B, C) such that : C := A - B /\ B \subset A
    hence :
    - B \subset A
    - C \subset A
    - C = A - B
    - B = A - C
    - A = B + C
    - nointer B C
 *)

let data_test_setlist_01 = [|
  ([1;2;3;4;5;10;11;12;14;15;16;17], [2], [1;3;4;5;10;11;12;14;15;16;17]);
  ([1;3;4;5;6;7;8;9;10;11;12;14;16;18], [7], [1;3;4;5;6;8;9;10;11;12;14;16;18]);
  ([0;4;5;6;8;9;10;12;13;14;15;16;17;18;19], [0], [4;5;6;8;9;10;12;13;14;15;16;17;18;19]);
  ([1;3;4;5;6;8;9;10;11;12;14;15;16;17;18;19], [1], [3;4;5;6;8;9;10;11;12;14;15;16;17;18;19]);
  ([3;4;5;6;8;9;10;11;12;13;14;15;16;17;18;19], [3;4;5;6;8;9;10;11;12;13;14;15;16;17;18;19], []);
|]

let gen_test_setlist_01 a b c () =
  error_assert
    "subset_of b a"
    (subset_of b a);
  error_assert
    "subset_of c a"
    (subset_of c a);
  let a_minus_b = minus a b in
  error_assert
    "c = a - b"
    (c = a_minus_b);
  let a_minus_c = minus a c in
  error_assert
    "b = a - c"
    (b = a_minus_c);
  let b_union_c = union b c in
  error_assert
    "a = b + c"
    (a = b_union_c);
  error_assert
    "nointer b c"
    (nointer b c);
  ()

let _ =
  Array.iteri (fun i (a, b, c) ->
    let tag = OUnit.ToS.("["^(int i)^"]") in
      push_test
        ("test_setlist_"^tag)
        (gen_test_setlist_01 a b c)
    ) data_test_setlist_01

let data_00 : int list list = [[187; 192]; [187; 191]; []; []; []; []; []; []; []; []; []; []; []; []; []; []; []; []; []; []; []; []; []; []; []; [148; 154]; [148; 152]; []; []; []; []; []; []; []; []; []; []; []; [128; 134]; [128; 132]; [128; 130]; []; []; []; []; []; []; []; []; [101; 106]; [101; 105]; []; []; []; []; []; []; []; []; []; []; []; []; []; []; []; []; []; []; []; []; []; []; []; []; []; [59; 64]; [59; 63]; []; []; []; []; []; []; []; []; []; []; []; [40; 45]; [40; 43]; [40; 42]; []; []; []; []; []; []; []; []; []; []; []; []; [171; 180]; [166; 176; 181]; [154; 177; 182; 192]; [132; 178; 186]; [139; 150; 174]; [137; 145]; [138; 142]; [121; 134; 151; 167]; [119; 126; 146]; [120; 123; 143]; [136; 160]; [118; 156; 161]; [147; 152; 157; 162]; [124; 127; 130; 158]; [86; 173; 189]; [81; 169; 184; 190]; [87; 103]; [82; 98; 104]; [84; 94]; [78; 90; 95]; [50; 61; 88]; [48; 56]; [49; 53]; [33; 45; 62; 79]; [31; 38; 57]; [32; 35; 54]; [47; 70]; [30; 66; 71]; [58; 63; 67; 72]; [36; 39; 42; 68]; [14; 43; 92; 100; 185]; [10; 64; 91; 96; 106; 191]; [12; 99]; [8; 105]; [189; 190; 191; 192]; [184; 185; 186]; [180; 181; 182]; [176; 177; 178]; [171; 173; 174]; [166; 167; 169]; [160; 161; 162]; [156; 157; 158]; [150; 151; 152; 154]; [145; 146; 147]; [142; 143]; [136; 137; 138; 139]; [128; 134]; [128; 130; 132]; [126; 127]; [123; 124]; [118; 119; 120; 121]; [103; 104; 105; 106]; [98; 99; 100]; [94; 95; 96]; [90; 91; 92]; [84; 86; 87; 88]; [78; 79; 81; 82]; [70; 71; 72]; [66; 67; 68]; [61; 62; 63; 64]; [56; 57; 58]; [53; 54]; [47; 48; 49; 50]; [40; 45]; [40; 42; 43]; [38; 39]; [35; 36]; [30; 31; 32; 33]; [12; 14]; [8; 10]]

let data_01_0 : int list list = [[187; 192]; [187; 191]; []; []; []; []; []; []; []; []; []; []; []; []; []; []; []; []; []; []; []; []; []; []; []; [148; 154]; [148; 152]; []; []; []; []; []; []; []; []; []; []; []; [128; 134]; [128; 132]; [128; 130]; []; []; []; []; []; []; []; []; [101; 106]; [101; 105]; []; []; []; []; []; []; []; []; []; []; []; []; []; []; []; []; []; []; []; []; []; []; []; []; []; [59; 64]; [59; 63]; []; []; []; []; []; []; []; []; []; []; []; [40; 45]; [40; 43]; [40; 42]; []; []; []; []; []; []; []; []; []; []; []; []; [171; 180]; [166; 176; 181]; [154; 177; 182; 192]; [132; 178; 186]; [139; 150; 174]; [137; 145]; [138; 142]; [121; 134; 151; 167]; [119; 126; 146]; [120; 123; 143]; [136; 160]; [118; 156; 161]; [147; 152; 157; 162]; [124; 127; 130; 158]; [86; 173; 189]; [81; 169; 184; 190]; [87; 103]; [82; 98; 104]; [84; 94]; [78; 90; 95]; [50; 61; 88]; [48; 56]; [49; 53]; [33; 45; 62; 79]; [31; 38; 57]; [32; 35; 54]; [47; 70]]
let data_01_1 : int list list = [[30; 66; 71]; [58; 63; 67; 72]; [36; 39; 42; 68]; [14; 43; 92; 100; 185]; [10; 64; 91; 96; 106; 191]; [12; 99]; [8; 105]; [189; 190; 191; 192]; [184; 185; 186]; [180; 181; 182]; [176; 177; 178]; [171; 173; 174]; [166; 167; 169]; [160; 161; 162]; [156; 157; 158]; [150; 151; 152; 154]; [145; 146; 147]; [142; 143]; [136; 137; 138; 139]; [128; 134]; [128; 130; 132]; [126; 127]; [123; 124]; [118; 119; 120; 121]; [103; 104; 105; 106]; [98; 99; 100]; [94; 95; 96]; [90; 91; 92]; [84; 86; 87; 88]; [78; 79; 81; 82]; [70; 71; 72]; [66; 67; 68]; [61; 62; 63; 64]; [56; 57; 58]; [53; 54]; [47; 48; 49; 50]; [40; 45]; [40; 42; 43]; [38; 39]; [35; 36]; [30; 31; 32; 33]; [12; 14]; [8; 10]]

let data_02_00 = [8; 10; 12; 14; 30; 31; 32; 33; 35; 36; 38; 39; 40; 42; 43; 45; 47; 48; 49; 50; 53; 54; 56; 57; 58; 59; 61; 62; 63; 64; 66; 67; 68; 70; 71; 72; 78; 79; 81; 82; 84; 86; 87; 88; 90; 91; 92; 94; 95; 96; 98; 99; 100; 101; 103; 104; 105; 106; 118; 119; 120; 121; 123; 124; 126; 127; 128; 130; 132; 134; 136; 137; 138; 139; 142; 143; 145; 146; 147; 148; 150; 151; 152; 154; 156; 157; 158; 160; 161; 162; 166; 167; 169; 171; 173; 174; 176; 177; 178; 180; 181; 182; 184; 185; 186; 187; 189; 190; 191; 192]
let data_02_01 = [0; 1; 2; 3; 4; 5]
let data_02_02 = [8; 10; 12; 14; 30; 31; 32; 33; 35; 36; 38; 39; 40; 42; 43; 45; 47; 48; 49; 50; 53; 54; 56; 57; 58; 59; 61; 62; 63; 64; 66; 67; 68; 70; 71; 72; 78; 79; 81; 82; 84; 86; 87; 88; 90; 91; 92; 94; 95; 96; 98; 99; 100; 101; 103; 104; 105; 106; 118; 119; 120; 121; 123; 124; 126; 127; 128; 130; 132; 134; 136; 137; 138; 139; 142; 143; 145; 146; 147; 148; 150; 151; 152; 154; 156; 157; 158; 160; 161; 162; 166; 167; 169; 171; 173; 174; 176; 177; 178; 180; 181; 182; 184; 185; 186; 187; 189; 190; 191; 192]

let test_minus_r00 () =
  let u = SetList.minus data_02_00 data_02_01 in
  print_error_endline(fun()->STools.ToS.(list int) u);
  assert(u = data_02_02);
  ()

let _ = push_test
  "test_minus_r00"
   test_minus_r00

let test_union_list_r01 () =
  let u = SetList.union_list data_00 in
  print_error_endline(fun()->STools.ToS.(list int) u);
  let u' = SetList.sort(MyList.rev_flatten data_00) in
  print_error_endline(fun()->STools.ToS.(list int) u');
  assert(u = u');
  ()

let _ = push_test
  "test_union_list_r01"
   test_union_list_r01

let _ = run_tests()
